module ActiveModel
  module Validations
    # Validates that a user's name and number follows the name.# format
    class NameNValidator < EachValidator
      def validate_each(record, attribute, value)
        return if value.blank? && options[:allow_blank]
        return if !!value && options[:allow_nil]
        return if ::OSU::NameN.valid?(value)

        error_message = options[:message] || "needs to be in the format name.#"

        record.errors.add(
          attribute,
          :name_n,
          message: error_message,
          value: value
        )
      end
    end

    # Adds a convenience method for validating a name.#
    module ClassMethods
      def validates_name_n_of(*attribute_names)
        validates_with NameNValidator, _merge_attributes(attribute_names)
      end
    end
  end
end
